/*
 * Decompiled with CFR 0.152.
 */
package fire.pb.main;

import fire.pb.main.DAGNode;
import java.util.LinkedList;
import java.util.TreeSet;

public class DAG<T extends Comparable<T>> {
    private final TreeSet<DAGNode<T>> nodes = new TreeSet();

    DAGNode<T> createNodeIfNotExist(T name) {
        DAGNode<T> n = this.getNode(name);
        if (n != null) {
            return n;
        }
        n = new DAGNode<T>(name, this);
        this.nodes.add(n);
        return n;
    }

    DAGNode<T> getNode(T name) {
        for (DAGNode<T> n : this.nodes) {
            if (!n.getName().equals(name)) continue;
            return n;
        }
        return null;
    }

    void walk(IWalk<T> w) {
        LinkedList<DAGNode<T>> walked = new LinkedList<DAGNode<T>>();
        for (DAGNode<T> n : this.nodes) {
            if (walked.contains(n)) continue;
            DAGNode<T> curr = n;
            while (true) {
                LinkedList<DAGNode<T>> parents = new LinkedList<DAGNode<T>>();
                int i = 0;
                while (i != curr.getPrevs().size()) {
                    DAGNode<T> p = curr.getPrevs().get(i);
                    if (walked.contains(p)) {
                        ++i;
                        continue;
                    }
                    if (parents.contains(p)) {
                        throw new RuntimeException("找到循环");
                    }
                    parents.push(curr);
                    curr = p;
                    i = 0;
                }
                w.onNode(curr);
                walked.add(curr);
                if (parents.isEmpty()) break;
                curr = (DAGNode<T>)parents.pollLast();
            }
            for (DAGNode<T> p : curr.getNexts()) {
                if (walked.contains(p)) continue;
                curr = p;
            }
        }
    }

    public static interface IWalk<T extends Comparable<T>> {
        public void onNode(DAGNode<T> var1);
    }
}

